//
//  SelfieModels.swift
//  FADModulePhoto
//
//  Created by Juan Carlos Pérez on 1/25/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit
import AVFoundation
import FirebaseMLVision

enum Selfie
{
  // MARK: Use cases
  
  enum Config
  {
    struct Request{
        var frontCamera = false
        var camSession: AVCaptureSession?
        var frontCameraDevice: AVCaptureDevice?
    }
    struct Response{
    }
    struct ViewModel{
        var companyDynamicImage : UIImage?
        var isProofLifeSelfie = false
        var frontCameraDevice: AVCaptureDevice?
        var camSession: AVCaptureSession?
        var videoOutput : AVCaptureVideoDataOutput?
    }
  }
   
    enum Camera
    {
        struct Session{
            var frontCameraDevice: AVCaptureDevice?
            var camSession: AVCaptureSession?
            var captureVideoDataOutputSampleBufferDelegate: AVCaptureVideoDataOutputSampleBufferDelegate?
            var videoOutput : AVCaptureVideoDataOutput?
        }
    }
    
    
    enum Photo
    {
        struct Request{
            var ciContext : CIContext?
            var sampleBuffer : CMSampleBuffer?
        }
        struct Response{
            var success : Bool
            var imgPhoto : UIImage?
            var timeToTakeSelfie : Double
        }
        struct ViewModel{
            var success : Bool
            var imgPhoto : UIImage?
            var timeToTakeSelfie : Double
        }
    }
    
    
    enum FaceDetection
    {
        struct Request{
            var visionImage: VisionImage
            var ciImage : CIImage
            var faceDetector : VisionFaceDetector?
            var frame: CGRect
            var actualState : String
        }
        struct Response{
            var success: Bool?
            var status : Int?
        }
        struct ViewModel{
            
        }
    }
    
    
    enum SmileDetector
    {
        struct Request{
            var smile : Int
            var face : VisionFace?
            var glassesTimeStamps : [Double]
        }
        struct Response{
            var glassesTimeStamps : [Double] = []
            var smileResult = 0
        }
        struct ViewModel{
            var glassesTimeStamps : [Double] = []
            var smileResult = 0
        }
    }
    
    enum BlinkDetector
    {
        struct Request{
            var blink : Int
            var face : VisionFace?
            var glassesTimeStamps : [Double]
        }
        struct Response{
            var glassesTimeStamps : [Double] = []
            var blinkResult = 0
        }
        struct ViewModel{
            var glassesTimeStamps : [Double] = []
            var blinkResult = 0
        }
    }
    
    
}
